<template>
  <div id="dashboard-page">
    <!-- OVERLAY CARD -->
    <vx-card class="overlay-card overflow-hidden">
      <template slot="no-body">
        <img :src="overlay_img" alt="banner" class="responsive" />
        <div class="card-overlay flex flex-row">
          <!-- DAILY GREETING -->
          <div class="w-1/3 px-8 flex flex-col justify-between">
            <vs-button
              @click.stop="function() {}"
              radius
              color="primary"
              type="filled"
              class="customize-btn"
              icon-pack="feather"
              icon="icon-settings"
            />
            <div v-if="timestamp.date" class="flex flex-col justify-end mb-8">
              <h1 class="text-white font-semibold o-80 mb-4">
                {{ dailyGreeting }},
                {{ this.activeUserInfo.displayName.split(" ")[0] }}!
              </h1>

              <h1 class="flex flex-row items-baseline mb-4">
                <span class="txt-big text-white font-bold o-90">
                  {{ timestamp.hour + ":" + timestamp.minute }}</span
                >
                <h1 class="text-white font-semibold o-80 ml-4">
                  {{ timestamp.time_suffix }}
                </h1>
              </h1>

              <h4 class="text-white font-semibold o-80 mb-4">
                {{ timestamp.date }}
              </h4>

              <p class="txt-small text-white o-60 mb-4">
                "{{ randomQuote.content }}"
              </p>
              <h6 class="txt-small text-white o-90 mb-4">
                - {{ randomQuote.author }}
              </h6>
            </div>
          </div>
          <!-- /DAILY GREETING -->

          <div class="w-2/3 h-full flex flex-col items-end">
            <div class="flex flex-row justify-end dashboard-icon-tabs">
              <feather-icon
                class="mx-4 inline-flex cursor-pointer hover:text-danger"
                icon="PlusCircleIcon"
                svgClasses="text-white"
                @click="addTask"
              />
              <div class="vertical-divider" />
              <feather-icon
                class="mx-4 inline-flex cursor-pointer hover:text-danger icon-tabs"
                :class="{ 'active-icon-tabs': activeTab == 0 }"
                icon="CheckCircleIcon"
                svgClasses="text-white"
                :badge="uncompletedList.length"
                @click="openTab(0)"
              />
              <feather-icon
                class="mx-4 inline-flex cursor-pointer hover:text-danger icon-tabs"
                :class="{ 'active-icon-tabs': activeTab == 1 }"
                icon="PieChartIcon"
                svgClasses="text-white"
                @click="openTab(1)"
              />
              <feather-icon
                class="mx-4 inline-flex cursor-pointer
              hover:text-danger icon-tabs"
                :class="{ 'active-icon-tabs': activeTab == 2 }"
                icon="BellIcon"
                svgClasses="text-white"
                :badge="notifications.length"
                @click="openTab(2)"
              />
              <div class="vertical-divider" />
              <!-- <DashboardSearchDropdown /> -->
              <!-- <SearchBar :onDashboard="true" iconSvgClasses="text-white" /> -->

              <ProfileDropDown :isOnlyIcon="true" />
            </div>
            <DashboardTodoList
              v-if="activeTab == 0"
              :tasks="uncompletedList"
              @edit="onClickEdit"
            />
            <DashboardChartInfo v-if="activeTab == 1" :info="taskStatistics" />
            <DashboardNotificationList
              v-if="activeTab == 2"
              :notifications="notifications"
            />
          </div>
        </div>
      </template>
    </vx-card>
  </div>
</template>

<script>
import VuePerfectScrollbar from "vue-perfect-scrollbar";
import ProfileDropDown from "../layouts/components/navbar/components/ProfileDropDown.vue";
import DashboardTodoList from "../presentations/dashboard/DashboardTodoList";
import DashboardChartInfo from "../presentations/dashboard/DashboardChartInfo";
import DashboardNotificationList from "../presentations/dashboard/DashboardNotificationList";
import quoteItems from "../presentations/dashboard/dailyQuoteItems";
import notificationItems from "../services/fake-db/notificationItems";
import TodoAddNew from "../presentations/todo/TodoAddNew.vue";
import TodoEdit from "../presentations/todo/TodoEdit.vue";
import SearchBar from "../layouts/components/navbar/components/SearchBar.vue";
import DashboardSearchDropdown from "../presentations/dashboard/DashboardSearchDropdown";

export default {
  components: {
    VuePerfectScrollbar,
    ProfileDropDown,
    DashboardNotificationList,
    DashboardChartInfo,
    DashboardTodoList,
    SearchBar,
    DashboardSearchDropdown
  },

  data() {
    return {
      overlay_img: require("@/assets/images/bg/aurora-borealis-1839582.jpg"),

      suggestingIndex: 0,

      timestamp: {
        hour: "",
        minute: "",
        time_suffix: "",
        date: ""
      },

      // config layout
      wasSidebarOpen: null,
      navbarSearchAndPinListBackup: null,
      footerTypeBackup: null,

      notifications: notificationItems,
      taskFilter: "all",

      activeTab: 2
    };
  },

  watch: {
    "$store.state.navbarSearchAndPinList.value"(val) {
      // case customizer is changed (this is not important ^^)
      if (val !== "hidden") {
        this.navbarSearchAndPinListBackup = val;
      }
    }
  },

  computed: {
    activeUserInfo() {
      return this.$store.state.AppActiveUser;
    },

    randomQuote() {
      var index = Math.floor(Math.random() * quoteItems.length);
      return quoteItems[index];
    },

    dailyGreeting() {
      // Good Evening: 5:00 PM — 4:59 AM
      if (
        (this.timestamp.time_suffix == "CH" && this.timestamp.hour >= 5) ||
        (this.timestamp.time_suffix == "SA" && this.timestamp.hour < 5)
      ) {
        return "Buổi tối vui vẻ";
      } else {
        // Good Morning: 5:00 AM — 11:59 AM
        if (
          this.timestamp.time_suffix == "SA" &&
          this.hour >= 5 &&
          this.hour < 12
        ) {
          return "Chào buổi sáng";
        }
      }
      // Good Afternoon: 12:00 PM — 4:59 PM
      return "Buổi chiều tốt đẹp";
    },

    taskStatistics() {
      return this.$store.getters["todo/taskStatistics"];
    },

    taskList() {
      return this.$store.getters["todo/queriedTasks"];
    },

    uncompletedList() {
      return this.$store.getters["todo/uncompletedList"];
    }
  },

  created() {
    const date = new Date();
    setInterval(this.getNow, 1000);

    /* TODO LIST */
    let filter = this.taskFilter;

    // Fetch Tasks
    this.$store.dispatch("todo/fetchTasks", {});

    this.$store.commit("todo/UPDATE_TODO_FILTER", filter);

    // Because filter feature is not supported by backend => manually in following line:
    this.$store.getters["todo/queriedTasks"];

    // Fetch Tags
    this.$store.dispatch("todo/fetchTags");

    // Fetch Project
    this.$store.dispatch("todo/fetchProjects");
    /* /TODO LIST  */
  },

  methods: {
    openTab(index) {
      this.activeTab = index;
    },
    getNow() {
      const checkTime = function(i) {
        if (i < 10) {
          i = "0" + i;
        }
        return i;
      };

      const date = new Date();

      var week = [
        "Chủ Nhật",
        "Thứ Hai",
        "Thứ Ba",
        "Thứ Tư",
        "Thứ Năm",
        "Thứ Sáu",
        "Thứ Bảy"
      ];
      let currDate = checkTime(date.getDate());
      let month = checkTime(date.getMonth());
      let year = checkTime(date.getFullYear());
      this.timestamp.date = `${
        week[date.getDay()]
      } ${currDate}/${month}/${year}`;

      let hour = date.getHours();
      let minute = checkTime(date.getMinutes());
      let ss = checkTime(date.getSeconds());

      if (hour > 12) {
        hour = hour - 12;
        hour = checkTime(hour);
        this.timestamp.hour = hour;
        this.timestamp.minute = minute;
        this.timestamp.time_suffix = "CH";
      } else {
        hour = checkTime(hour);

        this.timestamp.hour = hour;
        this.timestamp.minute = minute;
        this.timestamp.time_suffix = "SA";
      }
    },
    async addTask() {
      try {
        await this.$showModal(TodoAddNew, {}, { width: 650 });
      } catch (error) {
        console.log(error);
      }
    },
    async onClickEdit(item) {
      try {
        await this.$showModal(TodoEdit, { info: item }, { width: 650 });
      } catch (error) {
        console.log(error);
      }
    }
  },

  mounted() {
    // toggle something of layout
    this.wasSidebarOpen = this.$store.state.reduceButton;
    this.navbarSearchAndPinListBackup = this.$store.state.navbarSearchAndPinList[
      "value"
    ];
    this.footerTypeBackup = this.$store.state.mainFooterType;
    this.$store.commit("TOGGLE_REDUCE_BUTTON", true);
    this.$store.commit("UPDATE_NAVBAR_SEARCH_AND_PIN_LIST", "hidden");
    this.$store.commit("UPDATE_FOOTER_TYPE", "hidden");

    /* TODO LIST  */
    this.$store.dispatch("todo/setTodoSearchQuery", "");
    /* /TODO LIST  */
  },

  beforeDestroy() {
    // recover something of layout
    if (!this.wasSidebarOpen) this.$store.commit("TOGGLE_REDUCE_BUTTON", false);
    this.$store.commit(
      "UPDATE_NAVBAR_SEARCH_AND_PIN_LIST",
      this.navbarSearchAndPinListBackup
    );
    this.$store.commit("UPDATE_FOOTER_TYPE", this.footerTypeBackup);
  }
};
</script>

<style lang="scss">
#dashboard-page {
  margin: -2.2rem;

  .overlay-card {
    .vx-card__collapsible-content {
      height: 100%;
    }
  }

  .overlay-card {
    height: 100vh;
    border-radius: 0rem;

    img {
      margin-bottom: 0em;
      padding-bottom: 0em;
    }

    .customize-btn {
      position: relative;
      top: 0;
      left: 0;
      // border-top-right-radius: 0;
      // border-bottom-right-radius: 0;
      z-index: 50000;

      .vs-icon {
        animation: spin 1.5s linear infinite;
      }
    }
    .txt-big {
      font-size: 5rem;
    }
    .txt-small {
      font-size: 1.1rem;
    }

    .icon-tabs {
      width: 38px !important;
      height: 38px !important;

      align-items: center;
      justify-content: center;
    }

    .active-icon-tabs {
      border-radius: 50%;
      background: rgba(255, 255, 255, 0.2) !important;
    }

    .dashboard-icon-tabs {
      // min-height: 50px;
    }

    .vertical-divider {
      height: auto;
      border-right: 1.5px solid rgba(253, 252, 252, 0.4);
      margin: 3px 15px;
      position: relative;
      display: flex;
    }
  }
}
</style>
